<?php /** @var MSTS_InvoiceMe_Block_Adminhtml_System_Config_Form_Indicator_Webhook_Status $this */ ?>

<script type="text/javascript">
    //<![CDATA[
    function checkInvoiceMeWebhooksStatus() {
        disableInvoiceMeButtons();
        new Ajax.Request('<?php echo $this->getAjaxCheckWebhooksStatus() ?>', {
            loaderArea: $('payment_msts_invoiceme'),
            asynchronous: true,

            onSuccess: function (transport) {
                var response;

                try {
                    response = transport.responseJSON || transport.responseText.evalJSON(true) || {};
                    var messagesElement = $('payment_msts_invoiceme_webhooks_status_messages');

                    removeOldStatusMessages(messagesElement);
                    addNewWebhookStatusMessages(messagesElement, response);

                    updateWebhookStatusTooltip(response);

                    enableInvoiceMeButtons();
                } catch (e) {
                    response = {};
                }
            }
        });
    }

    function removeOldStatusMessages(messagesElement) {
        while (messagesElement.hasChildNodes()) {
            messagesElement.removeChild(messagesElement.lastChild);
        }
    }

    function addNewWebhookStatusMessages(messagesElement, response) {
        if (!response.hasOwnProperty('statusCreated')) {
            return;
        }
        var statusCreatedMessageCssClass = 'error-msg';
        if ('success' === response.statusCreated) {
            statusCreatedMessageCssClass = 'success-msg';
        }
        addWebhookStatusMessage(messagesElement, response.messageCreated, statusCreatedMessageCssClass);

        if (!response.hasOwnProperty('statusApiKey')) {
            return;
        }
        var statusApiKeyMessageCssClass = 'success-msg';
        if ('warning' === response.statusApiKey) {
            statusApiKeyMessageCssClass = 'warning-msg';
        }
        addWebhookStatusMessage(messagesElement, response.messageApiKey, statusApiKeyMessageCssClass);

        if (!response.hasOwnProperty('statusBaseUrl')) {
            return;
        }
        var statusBaseUrlMessageCssClass = 'success-msg';
        if ('warning' === response.statusBaseUrl) {
            statusBaseUrlMessageCssClass = 'warning-msg';
        }
        addWebhookStatusMessage(messagesElement, response.messageBaseUrl, statusBaseUrlMessageCssClass);
    }

    function addWebhookStatusMessage(messagesElement, message, messageCssClass) {
        var statusMessage = new Element('li');
        messagesElement.insert({'bottom': statusMessage});
        statusMessage.update(message);
        statusMessage.addClassName(messageCssClass);
    }

    function updateWebhookStatusTooltip(response) {
        var tooltipContent = '';
        if (response.hasOwnProperty('tooltip')) {
            tooltipContent = response.tooltip;
        }
        var webhookStatusTooltip = $('row_payment_msts_invoiceme_buyer_status_webhook_status').select('div.field-tooltip').first();
        webhookStatusTooltip.update('<div>' + tooltipContent + '</div>');

        if ('' === tooltipContent) {
            webhookStatusTooltip.hide();
        } else {
            webhookStatusTooltip.show();
        }
    }

    function enableInvoiceMeButtons() {
        enableInvoiceMeCheckCreatedWebhooksButton();
        enableInvoiceMeCreateWebhooksButton();
        enableInvoiceMeDeleteWebhooksButton();
    }

    function disableInvoiceMeButtons() {
        disableInvoiceMeCheckCreatedWebhooksButton();
        disableInvoiceMeCreateWebhooksButton();
        disableInvoiceMeDeleteWebhooksButton();
    }

    Event.observe(window, 'load', function(){
        checkInvoiceMeWebhooksStatus();
    });
    //]]>
</script>
<ul id="payment_msts_invoiceme_webhooks_status_messages" class="messages" style="min-width:280px">
    <li></li>
</ul>
